<?php
// $Id: imagefield_focus_imagecache_actions.inc,v 1.6 2011/01/09 15:01:24 anrikun Exp $

/**
 * @file
 * Written by Henri MEDOT <henri.medot[AT]absyx[DOT]fr>
 * http://www.absyx.fr
 */

/**
 * Focus Scale and Crop
 */
function imagefield_focus_scale_and_crop_form($data = array()) {
  $form['width'] = array(
    '#type' => 'textfield',
    '#title' => t('Width'),
    '#default_value' => isset($data['width']) ? $data['width'] : '',
    '#description' => t('Enter a value in pixels (e.g. 500).'),
  );
  $form['height'] = array(
    '#type' => 'textfield',
    '#title' => t('Height'),
    '#default_value' => isset($data['height']) ? $data['height'] : '',
    '#description' => t('Enter a value in pixels (e.g. 500).'),
  );
  return $form;
}



function theme_imagefield_focus_scale_and_crop($element) {
  return theme('imagecache_scale_and_crop', $element);
}



function imagefield_focus_scale_and_crop_image(&$image, $data) {
  module_load_include('inc', 'imagecache', 'imagecache_actions');
  if ($imagefield = imagefield_focus_find($image->source)) {
    $xoffset = 0;
    $yoffset = 0;

    if (($rect = @$imagefield->data['crop_rect']) && ($rect = imagefield_focus_parse($rect))) {
      if (!imagecache_crop_image($image, $rect)) {
        return FALSE;
      }
      $xoffset = $rect['xoffset'];
      $yoffset = $rect['yoffset'];
    }

    if (($rect = @$imagefield->data['focus_rect']) && ($rect = imagefield_focus_parse($rect))) {
      $rect['xoffset'] -= $xoffset;
      $rect['yoffset'] -= $yoffset;

      $scale = min($data['width'] / $rect['width'], $data['height'] / $rect['height']);
      $width0 = $image->info['width'] * $scale;
      $height0 = $image->info['height'] * $scale;
      if (!imagecache_resize_image($image, array('width' => $width0, 'height' => $height0))) {
        return FALSE;
      }

      foreach ($rect as $key => $value) {
        $rect[$key] = $value * $scale;
      }
      $width = min($width0, $data['width']);
      $height = min($height0, $data['height']);
      $xoffset = min($width0 - $width, max(0, $rect['xoffset'] + ($rect['width'] - $width) / 2));
      $yoffset = min($height0 - $height, max(0, $rect['yoffset'] + ($rect['height'] - $height) / 2));
      return imagecache_crop_image($image, array('xoffset' => $xoffset, 'yoffset' => $yoffset, 'width' => $width, 'height' => $height));
    }
  }

  return imagecache_scale_and_crop_image($image, $data);
}
